/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the TikTokControllerActionAudienceDimensionRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TikTokControllerActionAudienceDimensionRequest{}

// TikTokControllerActionAudienceDimensionRequest struct for TikTokControllerActionAudienceDimensionRequest
type TikTokControllerActionAudienceDimensionRequest struct {
	ReportType *string `json:"reportType,omitempty"`
	DataLevel  *string `json:"dataLevel,omitempty"`
}

// NewTikTokControllerActionAudienceDimensionRequest instantiates a new TikTokControllerActionAudienceDimensionRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTikTokControllerActionAudienceDimensionRequest() *TikTokControllerActionAudienceDimensionRequest {
	this := TikTokControllerActionAudienceDimensionRequest{}
	return &this
}

// NewTikTokControllerActionAudienceDimensionRequestWithDefaults instantiates a new TikTokControllerActionAudienceDimensionRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTikTokControllerActionAudienceDimensionRequestWithDefaults() *TikTokControllerActionAudienceDimensionRequest {
	this := TikTokControllerActionAudienceDimensionRequest{}
	return &this
}

// GetReportType returns the ReportType field value if set, zero value otherwise.
func (o *TikTokControllerActionAudienceDimensionRequest) GetReportType() string {
	if o == nil || IsNil(o.ReportType) {
		var ret string
		return ret
	}
	return *o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokControllerActionAudienceDimensionRequest) GetReportTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ReportType) {
		return nil, false
	}
	return o.ReportType, true
}

// HasReportType returns a boolean if a field has been set.
func (o *TikTokControllerActionAudienceDimensionRequest) HasReportType() bool {
	if o != nil && !IsNil(o.ReportType) {
		return true
	}

	return false
}

// SetReportType gets a reference to the given string and assigns it to the ReportType field.
func (o *TikTokControllerActionAudienceDimensionRequest) SetReportType(v string) {
	o.ReportType = &v
}

// GetDataLevel returns the DataLevel field value if set, zero value otherwise.
func (o *TikTokControllerActionAudienceDimensionRequest) GetDataLevel() string {
	if o == nil || IsNil(o.DataLevel) {
		var ret string
		return ret
	}
	return *o.DataLevel
}

// GetDataLevelOk returns a tuple with the DataLevel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokControllerActionAudienceDimensionRequest) GetDataLevelOk() (*string, bool) {
	if o == nil || IsNil(o.DataLevel) {
		return nil, false
	}
	return o.DataLevel, true
}

// HasDataLevel returns a boolean if a field has been set.
func (o *TikTokControllerActionAudienceDimensionRequest) HasDataLevel() bool {
	if o != nil && !IsNil(o.DataLevel) {
		return true
	}

	return false
}

// SetDataLevel gets a reference to the given string and assigns it to the DataLevel field.
func (o *TikTokControllerActionAudienceDimensionRequest) SetDataLevel(v string) {
	o.DataLevel = &v
}

func (o TikTokControllerActionAudienceDimensionRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TikTokControllerActionAudienceDimensionRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ReportType) {
		toSerialize["reportType"] = o.ReportType
	}
	if !IsNil(o.DataLevel) {
		toSerialize["dataLevel"] = o.DataLevel
	}
	return toSerialize, nil
}

type NullableTikTokControllerActionAudienceDimensionRequest struct {
	value *TikTokControllerActionAudienceDimensionRequest
	isSet bool
}

func (v NullableTikTokControllerActionAudienceDimensionRequest) Get() *TikTokControllerActionAudienceDimensionRequest {
	return v.value
}

func (v *NullableTikTokControllerActionAudienceDimensionRequest) Set(val *TikTokControllerActionAudienceDimensionRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableTikTokControllerActionAudienceDimensionRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableTikTokControllerActionAudienceDimensionRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTikTokControllerActionAudienceDimensionRequest(val *TikTokControllerActionAudienceDimensionRequest) *NullableTikTokControllerActionAudienceDimensionRequest {
	return &NullableTikTokControllerActionAudienceDimensionRequest{value: val, isSet: true}
}

func (v NullableTikTokControllerActionAudienceDimensionRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTikTokControllerActionAudienceDimensionRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
